#ifndef LIBDCITUNER_H
#define LIBDCITUNER_H

#include <stdint.h>

#define LIBDCITUNER_TV_MODE_ATV_AIR 0
#define LIBDCITUNER_TV_MODE_ATV_CABLE 1
#define LIBDCITUNER_TV_MODE_DTV 2

#define LIBDCITUNER_COUNTRY_ID_ALBANIA 0x01
#define LIBDCITUNER_COUNTRY_ID_ARGENTINA 0x07
#define LIBDCITUNER_COUNTRY_ID_AUSTRALIA 0x09
#define LIBDCITUNER_COUNTRY_ID_AUSTRIA 0x0A
#define LIBDCITUNER_COUNTRY_ID_AZERBAIJAN 0x0B
#define LIBDCITUNER_COUNTRY_ID_BELARUS 0x10
#define LIBDCITUNER_COUNTRY_ID_BELGIUM 0x11
#define LIBDCITUNER_COUNTRY_ID_BOLIVIA 0x15
#define LIBDCITUNER_COUNTRY_ID_BRAZIL 0x17
#define LIBDCITUNER_COUNTRY_ID_BRUNEI 0x18
#define LIBDCITUNER_COUNTRY_ID_BULGARIA 0x19
#define LIBDCITUNER_COUNTRY_ID_CHILE 0x1D
#define LIBDCITUNER_COUNTRY_ID_COLUMBIA 0x1F
#define LIBDCITUNER_COUNTRY_ID_COSTA_RICA 0x21
#define LIBDCITUNER_COUNTRY_ID_CROATIA 0x22
#define LIBDCITUNER_COUNTRY_ID_CYPRUS 0x24
#define LIBDCITUNER_COUNTRY_ID_CZECH_REPUBLIC 0x25
#define LIBDCITUNER_COUNTRY_ID_DENMARK 0x26
#define LIBDCITUNER_COUNTRY_ID_ECUADOR 0x2A
#define LIBDCITUNER_COUNTRY_ID_EGYPT 0x2B
#define LIBDCITUNER_COUNTRY_ID_ESTONIA 0x2D
#define LIBDCITUNER_COUNTRY_ID_FINLAND 0x30
#define LIBDCITUNER_COUNTRY_ID_FRANCE 0x31
#define LIBDCITUNER_COUNTRY_ID_GERMANY 0x35
#define LIBDCITUNER_COUNTRY_ID_GREECE 0x36
#define LIBDCITUNER_COUNTRY_ID_GUATEMALA 0x3A
#define LIBDCITUNER_COUNTRY_ID_HUNGARY 0x42
#define LIBDCITUNER_COUNTRY_ID_ICELAND 0x43
#define LIBDCITUNER_COUNTRY_ID_INDIA 0x44
#define LIBDCITUNER_COUNTRY_ID_INDONESIA 0x45
#define LIBDCITUNER_COUNTRY_ID_IRELAND 0x48
#define LIBDCITUNER_COUNTRY_ID_ISRAEL 0x49
#define LIBDCITUNER_COUNTRY_ID_ITALY 0x4A
#define LIBDCITUNER_COUNTRY_ID_JAPAN 0x4D
#define LIBDCITUNER_COUNTRY_ID_KAZAKHSTAN 0x4F
#define LIBDCITUNER_COUNTRY_ID_KUWAIT 0x51
#define LIBDCITUNER_COUNTRY_ID_LATVIA 0x52
#define LIBDCITUNER_COUNTRY_ID_LITHUANIA 0x57
#define LIBDCITUNER_COUNTRY_ID_LUXEMBOURG 0x58
#define LIBDCITUNER_COUNTRY_ID_MACEDONIA 0x5A
#define LIBDCITUNER_COUNTRY_ID_MALAYSIA 0x5D
#define LIBDCITUNER_COUNTRY_ID_MALDIVES 0x5E
#define LIBDCITUNER_COUNTRY_ID_MONTENEGRO 0xA8
#define LIBDCITUNER_COUNTRY_ID_NETHERLANDS_HOLLAND 0x3F
#define LIBDCITUNER_COUNTRY_ID_NEW_ZEALAND 0x6A
#define LIBDCITUNER_COUNTRY_ID_NORWAY 0x6E
#define LIBDCITUNER_COUNTRY_ID_PANAMA 0x71
#define LIBDCITUNER_COUNTRY_ID_PERU 0x73
#define LIBDCITUNER_COUNTRY_ID_PHILIPPINES 0x74
#define LIBDCITUNER_COUNTRY_ID_POLAND 0x75
#define LIBDCITUNER_COUNTRY_ID_PORTUGAL 0x76
#define LIBDCITUNER_COUNTRY_ID_QATAR 0x78
#define LIBDCITUNER_COUNTRY_ID_ROMANIA 0x7A
#define LIBDCITUNER_COUNTRY_ID_RUSSIA 0x7B
#define LIBDCITUNER_COUNTRY_ID_SAUDI_ARABIA 0x7F
#define LIBDCITUNER_COUNTRY_ID_SERBIA 0x80
#define LIBDCITUNER_COUNTRY_ID_SINGAPORE 0x83
#define LIBDCITUNER_COUNTRY_ID_SLOVAKIA 0x84
#define LIBDCITUNER_COUNTRY_ID_SLOVENIA 0x85
#define LIBDCITUNER_COUNTRY_ID_SURINAME 0x8B
#define LIBDCITUNER_COUNTRY_ID_SPAIN 0x88
#define LIBDCITUNER_COUNTRY_ID_SWEDEN 0x8C
#define LIBDCITUNER_COUNTRY_ID_SWITZERLAND 0x8D
#define LIBDCITUNER_COUNTRY_ID_TAIWAN 0x90
#define LIBDCITUNER_COUNTRY_ID_THAILAND 0x92
#define LIBDCITUNER_COUNTRY_ID_TURKEY 0x96
#define LIBDCITUNER_COUNTRY_ID_TURKMENISTAN 0xA7
#define LIBDCITUNER_COUNTRY_ID_UNITED_ARAB_EMIRATES 0x9A
#define LIBDCITUNER_COUNTRY_ID_UNITED_KINGDOM 0x9B
#define LIBDCITUNER_COUNTRY_ID_URUGUAY 0x9C
#define LIBDCITUNER_COUNTRY_ID_VENEZUELA 0x9F
#define LIBDCITUNER_COUNTRY_ID_VIETNAM 0xA0
#define LIBDCITUNER_COUNTRY_ID_CHINA_MAINLAND 0x1E
#define LIBDCITUNER_COUNTRY_ID_CHINA_HONG_KONG 0x41

#define LIBDCITUNER_VIDEO_RESOLUTION_480I_576I 0
#define LIBDCITUNER_VIDEO_RESOLUTION_480P_576P 1
#define LIBDCITUNER_VIDEO_RESOLUTION_720P 2
#define LIBDCITUNER_VIDEO_RESOLUTION_1080I 3

typedef struct libdcituner_t libdcituner_t;
typedef void (*libdcituner_event_cb_t)(int, void *, void *);

typedef struct libdcituner_channel_item_t {
    int tv_mode;
    int index;
    int main;
    int sub;
} libdcituner_channel_item_t;

typedef struct libdcituner_channel_list_t libdcituner_channel_list_t;

libdcituner_t * libdcituner_tuner_new(libdcituner_event_cb_t callback,
                                      void * callback_object);
void libdcituner_tuner_release(libdcituner_t * tuner);
void libdcituner_register_event_callback(libdcituner_t * tuner,
        libdcituner_event_cb_t cb);
int libdcituner_scan(libdcituner_t * tuner, uint16_t country_id,
                     uint8_t tv_mode, uint8_t scan_dvbc,
                     libdcituner_event_cb_t scan_started_callback,
                     libdcituner_event_cb_t callback);
int libdcituner_abort_scan(libdcituner_t * tuner);
int libdcituner_osd(libdcituner_t * tuner, bool enable);
void libdcituner_set_callback_object(libdcituner_t * tuner, void * obj);
int libdcituner_get_usb_storage_available_firmware_version(
    libdcituner_t * tuner, char * path, libdcituner_event_cb_t callback);
char * libdcituner_available_firmware_version(libdcituner_t * tuner);
int libdcituner_start_firmware_load(libdcituner_t * tuner, char * usb_path,
                                    libdcituner_event_cb_t callback,
                                    libdcituner_event_cb_t error_callback);

int libdcituner_channel_up(libdcituner_t * tuner);
int libdcituner_channel_down(libdcituner_t * tuner);

int libdcituner_set_channel(libdcituner_t * tuner, int channel_number);
int libdcituner_set_channel_full(libdcituner_t * tuner, int channel_number,
                                 libdcituner_event_cb_t callback);
int libdcituner_set_tv_mode(libdcituner_t * tuner, int tv_mode,
                            libdcituner_event_cb_t callback);

int libdcituner_set_video_resolution(libdcituner_t * tuner, int resolution);

char * libdcituner_get_firmware_version(libdcituner_t * tuner);
char * libdcituner_get_tv_card_model(libdcituner_t * tuner);
char * libdcituner_get_tv_mode(libdcituner_t * tuner);
int libdcituner_get_tv_country(libdcituner_t * tuner);
char * libdcituner_get_tv_country_id_str(int tv_country);
int libdcituner_get_channel_count(libdcituner_t * tuner);
int libdcituner_get_current_channel_number(libdcituner_t * tuner);
int libdcituner_get_subtitle_count(libdcituner_t * tuner);
int libdcituner_get_subtitle_option(libdcituner_t * tuner);
int libdcituner_set_subtitle_option(libdcituner_t * tuner, uint8_t index);
int libdcituner_factory_reset(libdcituner_t * tuner);

libdcituner_channel_item_t * libdcituner_get_channel_item(libdcituner_t * tuner,
        int index);

int libdcituner_import_channel_list(libdcituner_t * tuner,
                                    libdcituner_channel_item_t * list, int list_size);
int libdcituner_export_channel_list(libdcituner_t * tuner,
                                    libdcituner_channel_item_t * list);

#endif
